/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006
 * graycardinalster@gmail.com
 *
 */

#ifndef DEFINE_DJOBS_H
#define DEFINE_DJOBS_H
#include "djob_t.h"

class DJobs : public EList
{
	public:
		DJobs ();
		~DJobs ();
		
		__djob_t * add (int pid, char * user_data = NULL);
		__djob_t * attach (__djob_t * j);
		__djob_t * zombie ();
		__djob_t * by_pid (pid_t pid);
		__djob_t * fork ();
		__djob_t * wait_all ();
	
	private:
		__djob_t * alloc_job ();
		void __close_job_fds (__djob_t * j);
		__djob_t * __do_zombie (pid_t pid, int status);
};

#endif


