/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2009
 * graycardinalster@gmail.com
 *
 */

#include <head.h>

char * strreplace (char * where, const char * from, const char * to)
{
	char * S;
	char * end;
	int len;

	if (!where || !from || !to)
		return NULL;

	if (EQ (from, to))
		return where;

	len = strlen (from);
	while (true) {
		S = strstr (where, from);
		if (! S)
			break;
		end = S + len;
		end = strdup (end);
		strcpy (S, to);
		strcat (where, end);
		free (end);
	}

	return where;
}

int replace_file (char * f_name, char * from, char * to)
{
	FILE * fi;
	FILE * fo;
	char * m_buf;
	char * fo_name;
	
	fi = fopen (f_name, "r");
	if (! fi)
		return -1;

	m_buf = CNEW(char, 512);
	strcpy (m_buf, f_name);
	strcat (m_buf, ".tmp");

	fo = fopen (m_buf, "w");
	fo_name = strdup (m_buf);

	if (! fo) {
		DROP (m_buf);
		fclose (fi);
		return -1;
	}

	while (fgets (m_buf, 512, fi)) {
		strreplace (m_buf, from, to);
		fprintf (fo, "%s", m_buf);
	}
	
	fclose (fi);
	fclose (fo);
	unlink (f_name);
	move_file (fo_name, f_name);
	DROP (fo_name);
	DROP (m_buf);

	return 0;
}

int replace ()
{
	int i;
	char *S;
	int count;
	char m_buf[256];

	strcpy (m_buf, ENV->replace_exp);
	S = strchr (m_buf, ',');
	if (! S)
		return -1;
	*S = '\0';
	++S;
	count = ENV->d_files->get_size ();
	for (i = 0; i < count; ++i) 
		replace_file (ENV->d_files->get (i), m_buf, S);

	return 0;
}


