/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006,2007
 * graycardinalster@gmail.com
 *
 */

#include <gclib/gclib.h>
#include <env.h>
#include <errno.h>

int split_tmp_files ()
{
	FILE * f_tmpfiles;
	FILE ** proc_files;
	char m_buf[512];
	int i = 0;

	f_tmpfiles = fopen (ENV->tmp_files, "r");
	if (! f_tmpfiles)
		return -1;
	
	proc_files = CNEW (FILE *, ENV->max_proc);
	memset (proc_files, 0, sizeof (FILE *) * ENV->max_proc);
	errno = 0;
	for (i = 0; i < ENV->max_proc; ++i) {
		sprintf (m_buf, "%s%i", ENV->tmp_files, i);
		unlink (m_buf);
		proc_files[i] = fopen (m_buf, "w");
		if (! proc_files[i]) {
			perror ("fopen");
			return -1;
		}
	}	
	
	i = 0;
	while (fgets (m_buf, 512, f_tmpfiles)) {
		fprintf (proc_files[i], "%s", m_buf);
		if (++i >= ENV->max_proc)
			i = 0;		
	}
	
	for (i = 0; i < ENV->max_proc; ++i) 
		fclose (proc_files[i]);
	
	return ENV->max_proc;
}

int remove_tmp_files ()
{
	char m_buf[512];
	int i = 0;

	for (i = 0; i < ENV->max_proc; ++i) {
		sprintf (m_buf, "%s%i", ENV->tmp_files, i);
		unlink (m_buf);
		sprintf (m_buf, "%s%i", ENV->tmp_tags, i);
		unlink (m_buf);
	}	
	
	unlink (ENV->tmp_files);
	unlink (ENV->tmp_tags);
	return ENV->max_proc;
}

